/* -*- mode: c++ -*- */
#ifndef SWIG__COMMON__FRAMECPP_MACROS_I
#define SWIG__COMMON__FRAMECPP_MACROS_I

#ifndef MAKE_REF
%define MAKE_REF(KLASS,BASE,base)

%{
  const KLASS ## :: ## base ## _type&
  KLASS ## _Ref ## BASE( KLASS * Source )
  {
    if ( Source->Ref ## BASE( ).size( ) <= 0 )
    {
      throw std::length_error( #KLASS "::" #base " no data available" );
    }
    return Source->Ref ## BASE( );
  }

  size_t KLASS ## _Ref ## BASE ## Size( KLASS * Source )
  {
    return Source->Ref ## BASE( ).size( );
  }
%}
%enddef
#endif /* MAKE_REF */

#ifndef TYPEDEF_CONTAINER
%define TYPEDEF_CONTAINER(KLASS, NAME)
  using FrameCPP::KLASS::NAME
%enddef
#endif /* TYPEDEF_CONTAINER */

#endif /* SWIG__COMMON__FRAMECPP_MACROS_I */
